# $Id: stylesheet.tcl,v 1.4 2001/04/17 13:37:43 tobotras Exp $

puts -nonewline stderr "Loading stylesheet..."

rtf:documentFormat {
    TopMargin		0.5in
    BottomMargin	0.5in
    FootnoteNumbering	Arabic
    FootnoteRestart	AtPage
    FootnotePlacement	PageBottom
}

# ------------------ rules

rtf:ruleStyle style_Border {
    Thickness 0.75pt
    Margin 1.5mm
}

rtf:ruleStyle rule_Table_Col_Sep {
    Thickness 0.75pt
}

rtf:ruleStyle rule_Table_Row_Sep {
    Margin 1mm
    Thickness 0.75pt
}

rtf:ruleStyle rule_Table_Frame {
    Thickness 0.75pt
}

# -------------------- sections

rtf:sectStyle style_titlepage "Title page" {
    LeftMargin		1cm
    RightMargin		1cm
    HasTitlePage	1
    SectionBreak	None
}

rtf:sectStyle style_body "Main part" {
    LeftMargin		3cm
    RightMargin		2cm
}

rtf:sectStyle style_contents "Table of contents" {
    LeftMargin		3cm
    RightMargin		2cm
}

rtf:sectStyle style_back "Back part" {
    LeftMargin		2cm
    RightMargin		1.5cm
}

rtf:sectStyle style_versioninfo "Versioning" {
    SectionBreak	Page
}

# -------------------- paragraphs

rtf:paraStyle style_Default "Default" {
    FontSize 12pt
    Font roman
    SpaceBefore 6pt
    LeftIndent 0pt
    FirstIndent 0mm
    LineSpacing 18pt
    Quadding Justify
}

rtf:paraStyle default "Normal" -basedon style_Default {
}

rtf:paraStyle style_TitleHead "Company name" -basedon style_Default {
    FontSize 16pt
    Quadding Center
    Underline Single
}

rtf:paraStyle style_TitlePart "Document title" -basedon style_Default {
    FontSize 18pt
    Font sans
    Quadding Center
    Underline Single
}

rtf:paraStyle style_TZ "TZ title" -basedon style_Default {
    FontSize 20pt
    Font sans
    Bold 1
    Quadding Center
}

rtf:paraStyle style_Head0 "Heading 1" -basedon style_Default {
    SpaceBefore 5mm
    Quadding Center
    FontSize 18pt
    Font sans
    Bold 1
}

rtf:paraStyle style_Head1 "Heading 2" -basedon style_Default {
    FontSize 16pt
    Bold 1
}

rtf:paraStyle style_Head2 "Heading 3" -basedon style_Head1 {
    LeftIndent 5mm
    FontSize 12pt
}

rtf:paraStyle style_Head3 "Heading 4" -basedon style_Head2 {
}

rtf:paraStyle style_Head4 "Heading 5" -basedon style_Head3 {
}

rtf:paraStyle style_StartDate "Start date" -basedon style_Default {
    Quadding Center
}

rtf:paraStyle style_item1 "Item 1" -basedon style_Default {
    LeftIndent 5mm
}

rtf:paraStyle style_item2 "Item 2" -basedon style_item1 {
    LeftIndent 10mm
}

rtf:paraStyle style_item3 "Item 3" -basedon style_item1 {
    LeftIndent 15mm
}

rtf:paraStyle style_item4 "Item 4" -basedon style_item1 {
    LeftIndent 20mm
}

rtf:paraStyle style_stages "Stages" -basedon style_item1 {
}

rtf:paraStyle style_stagecontent "Stage Content" -basedon style_item1 {
}

rtf:paraStyle style_stagedocuments "Stage Documents" -basedon style_item1 {
}

rtf:paraStyle style_List_Item1 "List 1" -basedon style_Default {
}

rtf:paraStyle style_List_Item2 "List 2" -basedon style_Default {
    LeftIndent 5mm
}

rtf:paraStyle style_List_Item3 "List 3" -basedon style_Default {
    LeftIndent 10mm
}

rtf:paraStyle style_List_Item4 "List 4" -basedon style_Default {
    LeftIndent 15mm
}

rtf:paraStyle style_List_Item5 "List 5" -basedon style_Default {
    LeftIndent 20mm
}

rtf:paraStyle style_List_Item6 "List 6" -basedon style_Default {
    LeftIndent 25mm
}

rtf:paraStyle style_List_Item7 "List 7" -basedon style_Default {
    LeftIndent 30mm
}

rtf:tabStops tocTabs {
    "5in Align Left Leaders Dot"
}

rtf:paraStyle style_TOC_1 "TOC level 1" -basedon style_Default {
    FontSize 14pt
    Bold 1
    TabStops tocTabs
}

rtf:paraStyle style_TOC_2 "TOC level 2" -basedon style_TOC_1 {
    Bold 0
    LeftIndent 10mm
}

rtf:paraStyle style_TOC_3 "TOC level 3" -basedon style_TOC_2 {
    LeftIndent 20mm
}

rtf:paraStyle style_Table_Cell "Table cell" -basedon style_Default {
    LeftIndent 1mm
    RightIndent 1mm
}

rtf:paraStyle style_TableHead "Table head" -basedon style_Default {
    FontSize 16pt
    Bold 1
}

rtf:paraStyle style_backTitle "Back matter headings" -basedon style_Default {
    FontSize 22pt
    Quadding Center
    SpaceAfter 6mm
}

# ---------------------------- char styles

rtf:charStyle style_Plain "Default" {
    FontSize 10pt
}

rtf:charStyle style_backTableHead "Back table heads" -basedon style_Plain {
    FontSize 12pt
    Bold 1
}

# ----------------------------

# Fallbacks for unknown styles
rtf:charStyle style_Unknown "Undefined" -basedon style_Plain {
    Bold 1
    Italic 1
}

rtf:paraStyle style_Unknown_Bold "Undefined" -basedon style_Default {
    Bold 1
    Italic 1
}

puts stderr ""
